function varargout = gui_aviso_altimetry(varargin)
% Boots-up AVISO Altimetry GUI, interacts with user via interface.
% gui_aviso_altimetry M-file for gui_aviso_altimetry.fig
%
% INPUT(S):
%
%   [none]
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% OPeNDAP Science Team
% Copyright 2008
% $Version 2.0.0$

%==========================================================================
% Meri Sheremet
% April 2008
%
% REVISION HISTORY:
% 2008/04/01 created, ms
% 2008/06/15 modified for compiled version, ceb
%==========================================================================

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_aviso_altimetry_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_aviso_altimetry_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_aviso_altimetry is made visible.
function gui_aviso_altimetry_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_aviso_altimetry (see VARARGIN)
% Define handles "openfigure" field.
if ~isfield(handles,'openfigure')
    handles.openfigure = 0; %set equal to zero on the first time.
end
% Set interface name.
filename = 'get_aviso_altimetry';
txt = ['NASA/REASoN Ocean Data Portal - '];
tmp1 = ['AVISO Altimetry GUI'];
tmp2 = '';
txt = [txt,tmp1];
if (~isdeployed)
    tmp2 = strrep(op_version('mfile',filename),'Version ','');
    txt = [txt,' (Ver ',tmp2,')'];
end
set(hObject,'Name',txt);

%Place logos on the GUI    
% determine screen resolution and size of character in pixels
Units0=get(0,'Units'); % save initial settings
set(0,'Units','characters');
SSC=get(0,'ScreenSize'); % screen size in characters
set(0,'Units','pixels');
SSP=get(0,'ScreenSize'); % screen size in pixels
set(0,'Units',Units0); % restore to original units
ppcx=SSP(3)/SSC(3); % pixels per character along x
ppcy=SSP(4)/SSC(4); % pixels per character along y

[img,MAP]=imread('logo_opendap.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton6,'CData',img)
pos = get(handles.pushbutton6,'position'); %units will be in characters
set(handles.pushbutton6,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_nasa1.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton7,'CData',img)
pos = get(handles.pushbutton7,'position'); %units will be in characters
set(handles.pushbutton7,'position',[pos(1),pos(2),CX,CY]);  

[img,MAP]=imread('logo_aviso.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton3,'CData',img)
pos = get(handles.pushbutton3,'position'); %units will be in characters
set(handles.pushbutton3,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_apdrc.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton4,'CData',img)
pos = get(handles.pushbutton4,'position'); %units will be in characters
set(handles.pushbutton4,'position',[pos(1),pos(2),CX,CY]);

set(handles.edit11,'String',num2str(1));
set(handles.edit12,'String',num2str(1));
set(handles.edit13,'String',num2str(1));

% Make 'Load Last Request' button inactive when file gui_xxx_request.mat is
% absent.
if ~exist('gui_aviso_altimetry_request.mat','file') 
    set(handles.pushbutton5,'Enable','Off')
end

SaveFilesOnOff(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)

%set(handles.pushbutton1,'String','Get Data','BackgroundColor',[0 1. 0.25])
% Update handles "openfigure" field.
handles.openfigure = 1;
% Choose default command line output for gui_aviso_altimetry
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_aviso_altimetry wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_aviso_altimetry_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

function popupmenu1_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)

function radiobutton1_Callback(hObject, eventdata, handles)
CheckExclusive(hObject, eventdata, handles,{'radiobutton1'},{'radiobutton2'})
CheckRanges(hObject, eventdata, handles)
function radiobutton2_Callback(hObject, eventdata, handles)
CheckExclusive(hObject, eventdata, handles,{'radiobutton2'},{'radiobutton1'})
CheckRanges(hObject, eventdata, handles)

function checkbox1_Callback(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
function checkbox3_Callback(hObject, eventdata, handles)
function checkbox4_Callback(hObject, eventdata, handles)
function checkbox5_Callback(hObject, eventdata, handles)
function checkbox6_Callback(hObject, eventdata, handles)
function checkbox7_Callback(hObject, eventdata, handles)
function checkbox8_Callback(hObject, eventdata, handles)
function checkbox9_Callback(hObject, eventdata, handles)

function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)

function popupmenu2_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
function popupmenu2_CreateFcn(hObject, eventdata, handles)

function popupmenu3_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
function popupmenu3_CreateFcn(hObject, eventdata, handles)

function edit11_Callback(hObject, eventdata, handles)
function edit11_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)

function popupmenu4_Callback(hObject, eventdata, handles)
function popupmenu4_CreateFcn(hObject, eventdata, handles)

function edit14_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)

function radiobutton3_Callback(hObject, eventdata, handles)
function radiobutton4_Callback(hObject, eventdata, handles)
SaveFilesOnOff(hObject, eventdata, handles)

function pushbutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton4,'Value') == 1
    DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
    set(handles.edit14,'String',DIRNAME)
end

% The main button that starts data acquisition
function pushbutton1_Callback(hObject, eventdata, handles)
% uiresume(handles.figure1)
% Turn off ability to re-issue "Get Data."
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait...');
pause(.1)

% Get input from user.
request=InputGet(hObject, eventdata, handles);

filename = 'gui_aviso_altimetry_request.mat';
if (~isdeployed)
    pname = mfilename('fullpath');
    pname = pname(1:length(pname)-length(mfilename)); %mfilename does not have .m in it
    filename = [pname,filename];
end
save(filename,'request','-mat')
set (handles.pushbutton5,'Enable','On')

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
% assignin('base','request',request);

get_aviso_altimetry(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25]);

function pushbutton3_Callback(hObject, eventdata, handles)
web 'http://www.aviso.oceanobs.com/en/data/data-access-services/opendap/index.html' -browser
function pushbutton4_Callback(hObject, eventdata, handles)
function pushbutton6_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton7_Callback(hObject, eventdata, handles)
%web 'http://www.nasa.gov/topics/earth/index.html' -browser
web 'http://www.nasa.gov' -browser

function request=InputGet(hObject, eventdata, handles)
DSI=LoadDSI(hObject, eventdata, handles);
R.DataSetBranch=DSI.DataSetBranch;
R.Satellite=DSI.Satellite;
R.TimeMode=DSI.TimeMode;
R.SpatialCoverage=DSI.SpatialCoverage;

R.Fields=DSI.Fields;
R.Fields(:,end+1)={'n'}; % add one more column to indicated checked fields
[NV,N2]=size(R.Fields);
% select only checked variables
for k=1:NV
CBNUM=num2str(DSI.Fields_CBNum{k});
    if eval(['get(handles.checkbox' CBNUM ',''Value'')']) == 1
    R.Fields{k,end}='y';    
    end
end

S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');
if ~iscell(S) S={S}; end
R.TAVG=S{j};

R.DATE1='00000000';
S=deblank(get(handles.edit1,'String'));R.DATE1(4-length(S)+1:4)=S;
S=deblank(get(handles.edit2,'String'));R.DATE1(6-length(S)+1:6)=S;
S=deblank(get(handles.edit3,'String'));R.DATE1(8-length(S)+1:8)=S;
R.DATE2='00000000';
S=deblank(get(handles.edit4,'String'));R.DATE2(4-length(S)+1:4)=S;
S=deblank(get(handles.edit5,'String'));R.DATE2(6-length(S)+1:6)=S;
S=deblank(get(handles.edit6,'String'));R.DATE2(8-length(S)+1:8)=S;
R.DATEINCR=str2num(deblank(get(handles.edit11,'String')));

R.LAT1=str2num(deblank(get(handles.edit7,'String')));
R.LAT2=str2num(deblank(get(handles.edit8,'String')));
R.LON1=str2num(deblank(get(handles.edit9,'String')));
R.LON2=str2num(deblank(get(handles.edit10,'String')));
R.LATINCR=str2num(deblank(get(handles.edit12,'String')));
R.LONINCR=str2num(deblank(get(handles.edit13,'String')));

R.SaveWorkspace='n'; 
if get(handles.radiobutton3,'Value') == 1 R.SaveWorkspace='y'; end
S=get(handles.popupmenu4,'String');j=get(handles.popupmenu4,'Value');
R.SaveMode=deblank(S{j});
R.SaveFiles='n'; 
if get(handles.radiobutton4,'Value') == 1 R.SaveFiles='y'; end
R.DIRNAME =deblank(get(handles.edit14,'String'));
if isempty(R.DIRNAME) R.DIRNAME=''; end
R.FNPREFIX=deblank(get(handles.edit15,'String'));

%R.RequestDate=datestr(now,'yyyy-mm-dd HH:MM:SS');
request=R;
handles.request=request;

% Load Last request
function pushbutton5_Callback(hObject, eventdata, handles)
filename = 'gui_aviso_altimetry_request.mat';
if exist(filename,'file')
    load(filename)
else
    msgbox(['File ',filename,' does not exist.']);
    return
end

R=request;

load dsi_aviso_altimetry.mat 

Satellite=R.Satellite;
TimeMode=R.TimeMode;
SpatialCoverage=R.SpatialCoverage;
DataSetBranch=R.DataSetBranch;

set(handles.popupmenu1,'String',List.Satellite(:,2))
j = strmatch(Satellite,List.Satellite(:,1),'exact');
set(handles.popupmenu1,'Value',j)

j = strmatch(TimeMode,List.TimeMode(:,1),'exact');
if j==1
    set(handles.radiobutton1,'Value',1);
    set(handles.radiobutton2,'Value',0);
else
    set(handles.radiobutton1,'Value',0);
    set(handles.radiobutton2,'Value',1);
end

%SpatialCoverage
[N1,N2]=size(List.SpatialCoverage);
jj=[];
for k=1:N1
j = strmatch(cell2mat([Satellite '_' TimeMode '_' List.SpatialCoverage(k,1)]),List.DataSetBranch(:,1),'exact');
    if ~isempty(j)
        jj=[jj ;k];
    end
end
SpatialCoverageL=List.SpatialCoverage(jj,:);

set(handles.popupmenu3,'String',SpatialCoverageL(:,2))
j = strmatch(SpatialCoverage,SpatialCoverageL(:,1),'exact');
set(handles.popupmenu3,'Value',j)

% Selected DataSetBranch
eval(['DSI=DSI_' DataSetBranch ';'])
DSI.List=List;

%DSI=LoadDSI(hObject, eventdata, handles);

% select only checked variables
[NV,N2]=size(R.Fields);
for k=1:NV
CBNUM=num2str(DSI.Fields_CBNum{k});
eval(['set(handles.checkbox' CBNUM ',''Value'',0)'])
    if R.Fields{k,end}=='y';
    eval(['set(handles.checkbox' CBNUM ',''Value'',1)']) 
    end
end

% get strings from GUI menu and convert them to numbers
set(handles.edit1,'String',R.DATE1(1:4));
set(handles.edit2,'String',R.DATE1(5:6)); 
set(handles.edit3,'String',R.DATE1(7:8)); 
set(handles.edit4,'String',R.DATE2(1:4));
set(handles.edit5,'String',R.DATE2(5:6)); 
set(handles.edit6,'String',R.DATE2(7:8)); 
set(handles.edit7,'String',num2str(R.LAT1));
set(handles.edit8,'String',num2str(R.LAT2));
set(handles.edit9,'String',num2str(R.LON1));
set(handles.edit10,'String',num2str(R.LON2));
set(handles.edit11,'String',num2str(R.DATEINCR));
set(handles.edit12,'String',num2str(R.LATINCR));
set(handles.edit13,'String',num2str(R.LONINCR));
set(handles.edit14,'String',R.DIRNAME);
set(handles.edit15,'String',R.FNPREFIX);

S=get(handles.popupmenu2,'String');
j=find(strcmp(S,R.TAVG)); if isempty(j) j=1; end
set(handles.popupmenu2,'Value',j);

set(handles.radiobutton3,'Value',0);
if R.SaveWorkspace=='y'
    set(handles.radiobutton3,'Value',1); 
end
S=get(handles.popupmenu4,'String');
j=find(strcmp(S,R.SaveMode)); if isempty(j) j=1; end
set(handles.popupmenu4,'Value',j);
set(handles.radiobutton4,'Value',0);
if R.SaveFiles=='y'
    set(handles.radiobutton4,'Value',1); 
end
SaveFilesOnOff(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)

function SaveFilesOnOff(hObject, eventdata, handles)
if get(handles.radiobutton3,'Value')==0 & get(handles.radiobutton4,'Value')==0
    set(handles.radiobutton3,'Value',1)
end

if isempty(get(handles.popupmenu4,'Value'))
    set(handles.popupmenu4,'Value',1);
end

if get(handles.radiobutton4,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton4,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

function DSI=LoadDSI(hObject, eventdata, handles)
load dsi_aviso_altimetry.mat
S=get(handles.popupmenu1,'String');
j=get(handles.popupmenu1,'Value');
S=S(j);
j = strmatch(S,List.Satellite(:,2),'exact');
Satellite=List.Satellite(j,1);

j=2;
if get(handles.radiobutton1,'Value')==1
    j=1;
end
TimeMode=List.TimeMode(j,1);

S=get(handles.popupmenu3,'String');
j=get(handles.popupmenu3,'Value');
if ~iscell(S) S={S}; end
S=S(j);
j = strmatch(S,List.SpatialCoverage(:,2),'exact');
SpatialCoverage=List.SpatialCoverage(j,1);

% Selected DataSetBranch
DataSetBranch=cell2mat([Satellite '_' TimeMode '_' SpatialCoverage]);
eval(['DSI=DSI_' DataSetBranch ';'])
DSI.List=List;

function CheckRanges(hObject, eventdata, handles)
% depending on the checked GUI buttons update appearence of GUI menu
load dsi_aviso_altimetry.mat % List

% Satellite
SatelliteL=List.Satellite;
set(handles.popupmenu1,'String',SatelliteL(:,2));
j=get(handles.popupmenu1,'Value');
if isempty(j)
    j=1;
end
Satellite=SatelliteL(j,1);

%TimeMode
set(handles.radiobutton1,'Enable','Off')
j = strmatch(cell2mat([Satellite '_' List.TimeMode(1,1)]),List.DataSetBranch(:,1));
if ~isempty(j)
set(handles.radiobutton1,'Enable','On')
end
set(handles.radiobutton2,'Enable','Off')
j = strmatch(cell2mat([Satellite '_' List.TimeMode(2,1)]),List.DataSetBranch(:,1));
if ~isempty(j)
set(handles.radiobutton2,'Enable','On')
end

if get(handles.radiobutton1,'Value')==0 & get(handles.radiobutton2,'Value')==0
    set(handles.radiobutton2,'Value',1)
end
if     get(handles.radiobutton1,'Value')==1 & strcmp(get(handles.radiobutton1,'Enable'),'on')
    j=1;
elseif get(handles.radiobutton1,'Value')==1 & strcmp(get(handles.radiobutton1,'Enable'),'off')
    set(handles.radiobutton1,'Value',0)
    set(handles.radiobutton2,'Value',1)
    j=2;
elseif get(handles.radiobutton2,'Value')==1 & strcmp(get(handles.radiobutton2,'Enable'),'on')
    j=2;
elseif get(handles.radiobutton2,'Value')==1 & strcmp(get(handles.radiobutton2,'Enable'),'off')
    set(handles.radiobutton1,'Value',1)
    set(handles.radiobutton2,'Value',0)
    j=1;
end
TimeMode=List.TimeMode(j,1);

%SpatialCoverage
[N1,N2]=size(List.SpatialCoverage);
jj=[];
for k=1:N1
j = strmatch(cell2mat([Satellite '_' TimeMode '_' List.SpatialCoverage(k,1)]),List.DataSetBranch(:,1),'exact');
    if ~isempty(j)
        jj=[jj ;k];
    end
end
SpatialCoverageL=List.SpatialCoverage(jj,:);
set(handles.popupmenu3,'String',SpatialCoverageL(:,2));
j=get(handles.popupmenu3,'Value');
if j>length(SpatialCoverageL(:,1))
    j=1; set(handles.popupmenu3,'Value',j)
end
SpatialCoverage=SpatialCoverageL(j,1);

% Selected DataSetBranch
DataSetBranch=cell2mat([Satellite '_' TimeMode '_' SpatialCoverage]);

eval(['DSI=DSI_' DataSetBranch ';'])

set(handles.popupmenu2,'String',DSI.TRes,'Value',1);

% CheckBoxes
L=[1:1:9]; % possible checkbox numbers
for k=1:length(L) % first make all field checkboxes inactive
CBNUM=num2str(L(k));
eval(['set(handles.checkbox' CBNUM ',''Enable'',''off'')'])
end
for k=1:length(DSI.Fields(:,1)) % make active only checked fields
    FIELDMENU=DSI.Fields_NameMenu{k};
    CBNUM=num2str(DSI.Fields_CBNum{k});
    eval(['set(handles.checkbox' CBNUM ',''Visible'',''on'',''Enable'',''on'',''String'',''' FIELDMENU ''')'])
end

%Ranges
set(handles.text5,'String',...
['Available time range: [' datestr(DSI.Range.Time1,'yyyy-mm-dd') ' to ' datestr(DSI.Range.Time2,'yyyy-mm-dd') ']'],'ForegroundColor',[0 0 1])
set(handles.text13,'String',...
['Available latitude range: [' num2str(DSI.Range.Latitude1) ' to ' num2str(DSI.Range.Latitude2) ']'],'ForegroundColor',[0 0 1])
set(handles.text17,'String',...
['Available longitude range: [' num2str(DSI.Range.Longitude1) ' to ' num2str(DSI.Range.Longitude2) ']'],'ForegroundColor',[0 0 1])
set(handles.text23,'String', ['Temporal resolution is ' DSI.TRes],'ForegroundColor',[0 0 1])
set(handles.text26 ,'String', ['Spatial resolution is ' DSI.HRes],'ForegroundColor',[0 0 1])

function CheckExclusive(hObject, eventdata, handles, Us, Them)
% sets value of Us to 1 and Them to 0
% example: Us={'radiobutton1'}; Them={'radiobutton2';'radiobutton3'}
for k=1:length(Us)
eval(['set(handles.' Us{k} ',''Value'',1)'])
end
for k=1:length(Them)
eval(['set(handles.' Them{k} ',''Value'',0)'])
end

