function varargout = gui_ghrsst(varargin)
% Boots-up GHRSST GUI, interacts with user via interface.
% gui_ghrsst M-file for gui_ghrsst.fig
%
% INPUT(S):
%
%   [none]
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% OPeNDAP Science Team
% Copyright 2008
% $Version 1.0.0$

%==========================================================================
% Meri Sheremet
% June 2008
%
% REVISION HISTORY:
% 2008/06/01 created, ms
% 2008/06/15 modified for compiled version, ceb
%==========================================================================

% Last Modified by GUIDE v2.5 01-Jul-2008 13:27:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_ghrsst_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_ghrsst_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_ghrsst is made visible.
function gui_ghrsst_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_ghrsst (see VARARGIN)

% Define handles "openfigure" field.
if ~isfield(handles,'openfigure')
    handles.openfigure = 0; %set equal to zero on the first time.
end

% Set interface name.
filename = 'get_ghrsst';
txt = ['NASA/REASoN Ocean Data Portal - '];
tmp1 = ['GHRSST GUI'];
tmp2 = '';
txt = [txt,tmp1];
if (~isdeployed)
    tmp2 = strrep(op_version('mfile',filename),'Version ','');
    txt = [txt,' (Ver ',tmp2,')'];
end
set(hObject,'Name',txt);

%Place logos on the GUI    
% determine screen resolution and size of character in pixels
Units0=get(0,'Units'); % save initial settings
set(0,'Units','characters');
SSC=get(0,'ScreenSize'); % screen size in characters
set(0,'Units','pixels');
SSP=get(0,'ScreenSize'); % screen size in pixels
set(0,'Units',Units0); % restore to original units
ppcx=SSP(3)/SSC(3); % pixels per character along x
ppcy=SSP(4)/SSC(4); % pixels per character along y

[img,MAP]=imread('logo_opendap.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton4,'CData',img)
pos = get(handles.pushbutton4,'position'); %units will be in characters
set(handles.pushbutton4,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_nasa1.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton6,'CData',img)
pos = get(handles.pushbutton6,'position'); %units will be in characters
set(handles.pushbutton6,'position',[pos(1),pos(2),CX,CY]); 

[img,MAP]=imread('logo_ghrsst.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton3,'CData',img)
pos = get(handles.pushbutton3,'position'); %units will be in characters
set(handles.pushbutton3,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_gdac.jpg');
[NY,NX,N3]=size(img);
CX=(NX+6)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+6)/ppcy;
set(handles.pushbutton7,'CData',img)
pos = get(handles.pushbutton7,'position'); %units will be in characters
set(handles.pushbutton7,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_ltsrf.jpg');
[NY,NX,N3]=size(img);
CX=(NX+6)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+6)/ppcy;
set(handles.pushbutton8,'CData',img)
pos = get(handles.pushbutton8,'position'); %units will be in characters
set(handles.pushbutton8,'position',[pos(1),pos(2),CX,CY]);

set(handles.edit11,'String',num2str(1));
set(handles.edit12,'String',num2str(1));
set(handles.edit13,'String',num2str(1));

% Make 'Load Last Request' button inactive when file gui_xxx_request.mat is
% absent.
if ~exist('gui_ghrsst_request.mat','file') 
    set(handles.pushbutton5,'Enable','Off')
end

SaveFilesOnOff(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)

% Update handles "openfigure" field.
handles.openfigure = 1;

% Choose default command line output for gui_ghrsst
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_ghrsst wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_ghrsst_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

function popupmenu1_Callback(hObject, eventdata, handles)   %Level
CheckRanges(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)
function popupmenu2_Callback(hObject, eventdata, handles)   %Product
CheckRanges(hObject, eventdata, handles)
function popupmenu2_CreateFcn(hObject, eventdata, handles)
function popupmenu3_Callback(hObject, eventdata, handles)   %Region
CheckRanges(hObject, eventdata, handles)
function popupmenu3_CreateFcn(hObject, eventdata, handles)
function popupmenu4_Callback(hObject, eventdata, handles)   %Mode
function popupmenu4_CreateFcn(hObject, eventdata, handles)
function popupmenu5_Callback(hObject, eventdata, handles)   %Dataset Branch
function popupmenu5_CreateFcn(hObject, eventdata, handles)
function popupmenu6_Callback(hObject, eventdata, handles)   %Temporal averages
function popupmenu6_CreateFcn(hObject, eventdata, handles)
function popupmenu7_Callback(hObject, eventdata, handles)   %Spatial resolution
function popupmenu7_CreateFcn(hObject, eventdata, handles)

function checkbox1_Callback(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
function checkbox3_Callback(hObject, eventdata, handles)
function checkbox4_Callback(hObject, eventdata, handles)
function checkbox5_Callback(hObject, eventdata, handles)
function checkbox6_Callback(hObject, eventdata, handles)
function checkbox7_Callback(hObject, eventdata, handles)
function checkbox8_Callback(hObject, eventdata, handles)
function checkbox9_Callback(hObject, eventdata, handles)
function checkbox10_Callback(hObject, eventdata, handles)
function checkbox11_Callback(hObject, eventdata, handles)
function checkbox12_Callback(hObject, eventdata, handles)
function checkbox13_Callback(hObject, eventdata, handles)
function checkbox14_Callback(hObject, eventdata, handles)
function checkbox15_Callback(hObject, eventdata, handles)
function checkbox16_Callback(hObject, eventdata, handles)
function checkbox17_Callback(hObject, eventdata, handles)
function checkbox18_Callback(hObject, eventdata, handles)
function checkbox19_Callback(hObject, eventdata, handles)

function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)

function edit11_Callback(hObject, eventdata, handles)
function edit11_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)

function edit14_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)

function radiobutton1_Callback(hObject, eventdata, handles)
function radiobutton2_Callback(hObject, eventdata, handles)
SaveFilesOnOff(hObject, eventdata, handles)

function pushbutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton2,'Value') == 1
    DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
    set(handles.edit14,'String',DIRNAME)
end

% The main button that starts data acquisition
function pushbutton1_Callback(hObject, eventdata, handles)
% uiresume(handles.figure1)
% Turn off ability to re-issue "Get Data."
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait...');
pause(.1)

% Get input from user.
request=InputGet(hObject, eventdata, handles);

% Save request to .mat file.
filename = 'gui_ghrsst_request.mat';
if (~isdeployed)
    pname = mfilename('fullpath');
    pname = pname(1:length(pname)-length(mfilename)); %mfilename does not have .m in it
    filename = [pname,filename];
end
save(filename,'request','-mat')
set(handles.pushbutton5,'Enable','On')

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
% assignin('base','request',request);

get_ghrsst(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25]);

function request=InputGet(hObject, eventdata, handles)

S=get(handles.popupmenu5,'String');j=get(handles.popupmenu5,'Value');
if ~iscell(S) S={S}; end
DataSetBranch=S{j};
R.DataSetBranch=DataSetBranch;

DSI=LoadDSI(hObject, eventdata, handles);

R.Fields=DSI.Fields;
R.Fields(:,end+1)={'n'}; % add one more column to indicated checked fields
[NV,N2]=size(R.Fields);
% select only checked variables
for k=1:NV
CBNUM=num2str(DSI.Fields_CBNum{k});
    if eval(['get(handles.checkbox' CBNUM ',''Value'')']) == 1
    R.Fields{k,end}='y';    
    end
end

%S=get(handles.popupmenu6,'String');j=get(handles.popupmenu6,'Value');
%if ~iscell(S) S={S}; end
%R.TAvg=S{j};
%S=get(handles.popupmenu7,'String');j=get(handles.popupmenu7,'Value');
%if ~iscell(S) S={S}; end
%R.HRes=S{j};

R.DATE1='00000000';
S=deblank(get(handles.edit1,'String'));R.DATE1(4-length(S)+1:4)=S;
S=deblank(get(handles.edit2,'String'));R.DATE1(6-length(S)+1:6)=S;
S=deblank(get(handles.edit3,'String'));R.DATE1(8-length(S)+1:8)=S;
R.DATE2='00000000';
S=deblank(get(handles.edit4,'String'));R.DATE2(4-length(S)+1:4)=S;
S=deblank(get(handles.edit5,'String'));R.DATE2(6-length(S)+1:6)=S;
S=deblank(get(handles.edit6,'String'));R.DATE2(8-length(S)+1:8)=S;
R.DATEINCR=str2num(deblank(get(handles.edit11,'String')));

R.LAT1=str2num(deblank(get(handles.edit7,'String')));
R.LAT2=str2num(deblank(get(handles.edit8,'String')));
R.LON1=str2num(deblank(get(handles.edit9,'String')));
R.LON2=str2num(deblank(get(handles.edit10,'String')));
R.LATINCR=str2num(deblank(get(handles.edit12,'String')));
R.LONINCR=str2num(deblank(get(handles.edit13,'String')));

R.SaveWorkspace='n'; 
if get(handles.radiobutton1,'Value') == 1 R.SaveWorkspace='y'; end
S=get(handles.popupmenu4,'String');j=get(handles.popupmenu4,'Value');
R.SaveMode=deblank(S{j});
R.SaveFiles='n'; 
if get(handles.radiobutton2,'Value') == 1 R.SaveFiles='y'; end
R.DIRNAME =deblank(get(handles.edit14,'String'));
if isempty(R.DIRNAME) R.DIRNAME=''; end
R.FNPREFIX=deblank(get(handles.edit15,'String'));

%R.RequestDate=datestr(now,'yyyy-mm-dd HH:MM:SS');
request=R;
handles.request=request;

function pushbutton3_Callback(hObject, eventdata, handles)
web 'http://www.ghrsst-pp.org/' -browser
function pushbutton4_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton6_Callback(hObject, eventdata, handles)
web 'http://www.nasa.gov' -browser
function pushbutton7_Callback(hObject, eventdata, handles)
web 'http://ghrsst.jpl.nasa.gov/' -browser
function pushbutton8_Callback(hObject, eventdata, handles)
web 'http://ghrsst.nodc.noaa.gov/' browser
   
% Load Last request
function pushbutton5_Callback(hObject, eventdata, handles)
filename = 'gui_ghrsst_request.mat';
if exist(filename,'file')
    load(filename)
else
    msgbox(['File ',filename,' does not exist.']);
    return
end

R=request;

load dsi_ghrsst.mat 

DataSetBranch=R.DataSetBranch;
set(handles.popupmenu5,'String',List.DataSetBranch(:,2))
j = strmatch(DataSetBranch,List.DataSetBranch(:,1),'exact');
set(handles.popupmenu5,'Value',j)
% Selected DataSetBranch
eval(['DSI=DSI_' DataSetBranch ';'])
DSI.List=List;

CheckLoadLastReq(hObject, eventdata, handles)
%DSI=LoadDSI(hObject, eventdata, handles);

% select only checked variables
[NV,N2]=size(R.Fields);
for k=1:NV
CBNUM=num2str(DSI.Fields_CBNum{k});
eval(['set(handles.checkbox' CBNUM ',''Value'',0)'])
    if R.Fields{k,end}=='y';
    eval(['set(handles.checkbox' CBNUM ',''Value'',1)']) 
    end
end

% get strings from GUI menu and convert them to numbers
set(handles.edit1,'String',R.DATE1(1:4));
set(handles.edit2,'String',R.DATE1(5:6)); 
set(handles.edit3,'String',R.DATE1(7:8)); 
set(handles.edit4,'String',R.DATE2(1:4));
set(handles.edit5,'String',R.DATE2(5:6)); 
set(handles.edit6,'String',R.DATE2(7:8)); 
set(handles.edit7,'String',num2str(R.LAT1));
set(handles.edit8,'String',num2str(R.LAT2));
set(handles.edit9,'String',num2str(R.LON1));
set(handles.edit10,'String',num2str(R.LON2));
set(handles.edit11,'String',num2str(R.DATEINCR));
set(handles.edit12,'String',num2str(R.LATINCR));
set(handles.edit13,'String',num2str(R.LONINCR));
set(handles.edit14,'String',R.DIRNAME);
set(handles.edit15,'String',R.FNPREFIX);

%S=get(handles.popupmenu2,'String');
%j=find(strcmp(S,R.TAVG)); if isempty(j) j=1; end
%set(handles.popupmenu2,'Value',j);

set(handles.radiobutton1,'Value',0);
if R.SaveWorkspace=='y'
    set(handles.radiobutton1,'Value',1); 
end
S=get(handles.popupmenu4,'String');
j=find(strcmp(S,R.SaveMode)); if isempty(j) j=1; end
set(handles.popupmenu4,'Value',j);
set(handles.radiobutton2,'Value',0);
if R.SaveFiles=='y'
    set(handles.radiobutton2,'Value',1); 
end
SaveFilesOnOff(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)


function SaveFilesOnOff(hObject, eventdata, handles)
if get(handles.radiobutton1,'Value')==0 & get(handles.radiobutton2,'Value')==0
    set(handles.radiobutton1,'Value',1)
end

if isempty(get(handles.popupmenu2,'Value'))
    set(handles.popupmenu2,'Value',1);
end

if get(handles.radiobutton2,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

function DSI=LoadDSI(hObject, eventdata, handles)
load dsi_ghrsst.mat
S=get(handles.popupmenu5,'String');j=get(handles.popupmenu5,'Value');
if ~iscell(S) S={S}; end
DataSetBranch=S{j};
eval(['DSI=DSI_' DataSetBranch ';'])
DSI.List=List;

function CheckRanges(hObject, eventdata, handles)
% depending on the checked GUI buttons update appearence of GUI menu
load dsi_ghrsst.mat % List

LevelL=List.Level;
set(handles.popupmenu1,'String',LevelL(:,2)); % long name
j=get(handles.popupmenu1,'Value');
if isempty(j) | (j>length(LevelL(:,1)))
    j=1; set(handles.popupmenu1,'Value');
end

Level=LevelL(j,1); % short name

%Product
[N1,N2]=size(List.DataSetBranch);
jj=[];
for k=1:N1
        if strcmp(List.DataSetBranch{k,3},Level)
        Product=List.DataSetBranch{k,4};
        j = strmatch(Product,List.Product(:,1),'exact');
        if ~isempty(j)
            jj=[jj ;j];
        else
            disp('warning: Product is not on the list')
            Product
            List.Product(:,1)
        end
    end
end
jj=unique(sort(jj)); % sort and remove duplicate entries
ProductL=List.Product(jj,:);
set(handles.popupmenu2,'String',ProductL(:,2)); % long name
j=get(handles.popupmenu2,'Value');
if isempty(j) | (j>length(ProductL(:,1)))
    j=1; set(handles.popupmenu2,'Value',j);
end
Product=ProductL(j,1); % short name

%Region
[N1,N2]=size(List.DataSetBranch);
jj=[];
for k=1:N1
    if strcmp(List.DataSetBranch{k,3},Level) & strcmp(List.DataSetBranch{k,4},Product)
        Region=List.DataSetBranch{k,5};
        j = strmatch(Region,List.Region(:,1),'exact');
        if ~isempty(j)
            jj=[jj ;j];
        else
            disp('warning: Region is not on the list')
            Region
            List.Region(:,1)
        end
    end
end
jj=unique(sort(jj)); % sort and remove duplicate entries
RegionL=List.Region(jj,:);
set(handles.popupmenu3,'String',RegionL(:,2)); % long name
j=get(handles.popupmenu3,'Value');
if isempty(j) | (j>length(RegionL(:,1)))
    j=1; set(handles.popupmenu3,'Value',j);
end
Region=RegionL(j,1); % short name

%DataSetBranch
[N1,N2]=size(List.DataSetBranch);
jj=[];
for k=1:N1
    if strcmp(List.DataSetBranch{k,3},Level) & strcmp(List.DataSetBranch{k,4},Product) & strcmp(List.DataSetBranch{k,5},Region)
        jj=[jj ;k];
    end
end
jj=unique(sort(jj)); % sort and remove duplicate entries
if length(jj)>1
disp('warning: DataSetBranch is not unique')
end
j=jj(1);
DataSetBranch=List.DataSetBranch{j,1};
set(handles.popupmenu5,'String',List.DataSetBranch(:,2)); % long name
set(handles.popupmenu5,'Value',j);

eval(['DSI=DSI_' DataSetBranch ';'])
DSI.TRes=List.DataSetBranch{j,6};
DSI.HRes=List.DataSetBranch{j,7};

%set(handles.popupmenu6,'String',DSI.TRes,'Value',1);
%set(handles.popupmenu7,'String',DSI.HRes,'Value',1);

% CheckBoxes
L=[1:1:19]; % possible checkbox numbers
for k=1:length(L) % first make all field checkboxes inactive
CBNUM=num2str(L(k));
eval(['set(handles.checkbox' CBNUM ',''Enable'',''off'')'])
end
for k=1:length(DSI.Fields(:,1)) % make active only checked fields
    FIELDMENU=DSI.Fields_NameMenu{k};
    CBNUM=num2str(DSI.Fields_CBNum{k});
    eval(['set(handles.checkbox' CBNUM ',''Visible'',''on'',''Enable'',''on'',''String'',''' FIELDMENU ''')'])
end

%Ranges
set(handles.text7,'String',...
['Available time range: [' datestr(DSI.Ranges.Time1,'yyyy-mm-dd') ' to ' datestr(DSI.Ranges.Time2,'yyyy-mm-dd') ']'],'ForegroundColor',[0 0 1])
set(handles.text15,'String',...
['Available latitude range: [' num2str(DSI.Ranges.Latitude1) ' to ' num2str(DSI.Ranges.Latitude2) ']'],'ForegroundColor',[0 0 1])
set(handles.text19,'String',...
['Available longitude range: [' num2str(DSI.Ranges.Longitude1) ' to ' num2str(DSI.Ranges.Longitude2) ']'],'ForegroundColor',[0 0 1])
set(handles.text23,'String', ['Temporal resolution is ' DSI.TRes],'ForegroundColor',[0 0 1])
set(handles.text26 ,'String', ['Spatial resolution is ' DSI.HRes],'ForegroundColor',[0 0 1])

function CheckExclusive(hObject, eventdata, handles, Us, Them)
% sets value of Us to 1 and Them to 0
% example: Us={'radiobutton1'}; Them={'radiobutton2';'radiobutton3'}
for k=1:length(Us)
eval(['set(handles.' Us{k} ',''Value'',1)'])
end
for k=1:length(Them)
eval(['set(handles.' Them{k} ',''Value'',0)'])
end

function CheckLoadLastReq(hObject, eventdata, handles)
% depending on the checked GUI buttons update appearence of GUI menu
load dsi_ghrsst.mat % List

S=get(handles.popupmenu5,'String');j=get(handles.popupmenu5,'Value');
if ~iscell(S) S={S}; end
DataSetBranch=S{j};

jds=j;
Level=List.DataSetBranch{jds,3};

LevelL=List.Level;
set(handles.popupmenu1,'String',LevelL(:,2)); % long name
j = strmatch(Level,LevelL(:,1),'exact');
if isempty(j) 
    j=1; 
end
set(handles.popupmenu1,'Value',j);

%Product
[N1,N2]=size(List.DataSetBranch);
jj=[];
for k=1:N1
        if strcmp(List.DataSetBranch{k,3},Level)
        Product=List.DataSetBranch{k,4};
        j = strmatch(Product,List.Product(:,1),'exact');
        if ~isempty(j)
            jj=[jj ;j];
        else
            disp('warning: Product is not on the list')
            Product
            List.Product(:,1)
        end
    end
end
jj=unique(sort(jj)); % sort and remove duplicate entries
ProductL=List.Product(jj,:);
set(handles.popupmenu2,'String',ProductL(:,2)); % long name
Product=List.DataSetBranch{jds,4};
j = strmatch(Product,ProductL(:,1),'exact');
if isempty(j) 
    j=1; 
end
set(handles.popupmenu2,'Value',j);

%Region
[N1,N2]=size(List.DataSetBranch);
jj=[];
for k=1:N1
    if strcmp(List.DataSetBranch{k,3},Level) & strcmp(List.DataSetBranch{k,4},Product)
        Region=List.DataSetBranch{k,5};
        j = strmatch(Region,List.Region(:,1),'exact');
        if ~isempty(j)
            jj=[jj ;j];
        else
            disp('warning: Region is not on the list')
        end
    end
end
jj=unique(sort(jj)); % sort and remove duplicate entries
RegionL=List.Region(jj,:);
set(handles.popupmenu3,'String',RegionL(:,2)); % long name
Region=List.DataSetBranch{jds,5};
j = strmatch(Region,RegionL(:,1),'exact');
if isempty(j) 
    j=1; 
end
set(handles.popupmenu3,'Value',j);


% --- Executes on button press in checkbox21.
function checkbox21_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox21


