function varargout = gui_hycom(varargin)
% Boots-up HYCOM GUI, interacts with user via interface.
% gui_hycom M-file for gui_hycom.fig
%
% INPUT(S):
%
%   [none] -- DataSetDATES is input to GUI to avoid using globals.
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% Meri Sheremet
% June 2007
% July 09, 2008 

warning('off','MATLAB:dispatcher:InexactMatch');


% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_hycom_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_hycom_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
%warning('on','MATLAB:dispatcher:InexactMatch');


% --- Executes just before gui_hycom is made visible.
function gui_hycom_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_hycom (see VARARGIN)


% Set interface name.
filename = 'get_hycom';
txt = [''];
tmp1 = ['HYCOM GUI'];
tmp2 = '';
txt = [txt,tmp1];
if (~isdeployed)
    tmp2 = strrep(op_version('mfile',filename),'Version ','');
    txt = [txt,' (Ver ',tmp2,')'];
end
set(hObject,'Name',txt);

%Place logos on the GUI    
% determine screen resolution and size of character in pixels
Units0=get(0,'Units'); % save initial settings
set(0,'Units','characters');
SSC=get(0,'ScreenSize'); % screen size in characters
set(0,'Units','pixels');
SSP=get(0,'ScreenSize'); % screen size in pixels
set(0,'Units',Units0); % restore to original units
ppcx=SSP(3)/SSC(3); % pixels per character along x
ppcy=SSP(4)/SSC(4); % pixels per character along y

[img,MAP]=imread('logo_opendap.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton7,'CData',img)
pos = get(handles.pushbutton7,'position'); %units will be in characters
set(handles.pushbutton7,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_nopp.jpg');
[NY,NX,N3]=size(img);
CX=(NX+4)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+4)/ppcy;
set(handles.pushbutton10,'CData',img)
pos = get(handles.pushbutton10,'position'); %units will be in characters
set(handles.pushbutton10,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_hycom.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;
CY=(NY+12)/ppcy;
set(handles.pushbutton6,'CData',img)
pos = get(handles.pushbutton6,'position'); %units will be in characters
set(handles.pushbutton6,'position',[pos(1),pos(2),CX,CY]);

[img,MAP]=imread('logo_coaps.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;
CY=(NY+12)/ppcy;
set(handles.pushbutton9,'CData',img)
pos = get(handles.pushbutton9,'position'); %units will be in characters
set(handles.pushbutton9,'position',[pos(1),pos(2),CX,CY]);

set(handles.popupmenu2,'Value',2);
CheckRanges(hObject, eventdata, handles)

LevelsOnOff(hObject, eventdata, handles)

%SaveFilesOnOff(hObject, eventdata, handles)
if get(handles.radiobutton1,'Value')==0 & get(handles.radiobutton2,'Value')==0
set(handles.radiobutton1,'Value',1)
end

if get(handles.radiobutton2,'Value') == 0
    set(handles.edit17,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit18,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit17,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit18,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

set(handles.pushbutton5,'String','Get Data','BackgroundColor',[0 1. 0.25])

% Make 'Load Last Request' button inactive when file gui_hycom_request.mat is
% absent
pname = strrep(mfilename('fullpath'),mfilename,'');
fname = [mfilename,'_request','.mat'];
%'gui_hycom_request.mat';
if ~exist([pname,fname],'file') 
    set (handles.pushbutton8,'Enable','Off')
end

% Update handles "openfigure" field.
handles.openfigure = 1;

% Choose default command line output for gui_hycom
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_hycom wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = gui_hycom_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

function checkbox1_Callback(hObject, eventdata, handles)
LevelsOnOff(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
LevelsOnOff(hObject, eventdata, handles)
function checkbox3_Callback(hObject, eventdata, handles)
LevelsOnOff(hObject, eventdata, handles)
function checkbox4_Callback(hObject, eventdata, handles)
LevelsOnOff(hObject, eventdata, handles)
function checkbox5_Callback(hObject, eventdata, handles)
LevelsOnOff(hObject, eventdata, handles)

function checkbox6_Callback(hObject, eventdata, handles)
function checkbox7_Callback(hObject, eventdata, handles)
function checkbox8_Callback(hObject, eventdata, handles)
function checkbox9_Callback(hObject, eventdata, handles)
function checkbox10_Callback(hObject, eventdata, handles)
function checkbox11_Callback(hObject, eventdata, handles)
function checkbox12_Callback(hObject, eventdata, handles)
function checkbox13_Callback(hObject, eventdata, handles)
function checkbox14_Callback(hObject, eventdata, handles)
function checkbox15_Callback(hObject, eventdata, handles)
function checkbox16_Callback(hObject, eventdata, handles)
function checkbox17_Callback(hObject, eventdata, handles)

function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)
function edit11_Callback(hObject, eventdata, handles)
function edit11_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)
function edit14_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)
function edit16_Callback(hObject, eventdata, handles)
function edit16_CreateFcn(hObject, eventdata, handles)
function edit17_Callback(hObject, eventdata, handles)
function edit17_CreateFcn(hObject, eventdata, handles)
function edit18_Callback(hObject, eventdata, handles)
function edit18_CreateFcn(hObject, eventdata, handles)

function radiobutton1_Callback(hObject, eventdata, handles)
function radiobutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton2,'Value') == 0
    set(handles.edit17,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit18,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit17,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit18,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

function popupmenu1_Callback(hObject, eventdata, handles)
function popupmenu1_CreateFcn(hObject, eventdata, handles)

%SaveFilesOnOff(hObject, eventdata, handles)

function pushbutton1_Callback(hObject, eventdata, handles)
S=get(handles.pushbutton1,'String');
if S(1) == 'S' % Select All
set(handles.checkbox1,'Value',1)
set(handles.checkbox2,'Value',1)
set(handles.checkbox3,'Value',1)
set(handles.checkbox4,'Value',1)
set(handles.checkbox5,'Value',1)
set(handles.pushbutton1,'String','Clear All')
elseif S(1) == 'C' % Clear All
set(handles.checkbox1,'Value',0)
set(handles.checkbox2,'Value',0)
set(handles.checkbox3,'Value',0)
set(handles.checkbox4,'Value',0)
set(handles.checkbox5,'Value',0)
set(handles.pushbutton1,'String','Select All')
end  
LevelsOnOff(hObject, eventdata, handles)

function pushbutton2_Callback(hObject, eventdata, handles)
S=get(handles.pushbutton2,'String');
if S(1) == 'S' % Select All
set(handles.checkbox6,'Value',1)
set(handles.checkbox7,'Value',1) 
set(handles.checkbox8,'Value',1)
set(handles.checkbox9,'Value',1)
set(handles.checkbox10,'Value',1)
set(handles.checkbox11,'Value',1)
set(handles.pushbutton2,'String','Clear All')
elseif S(1) == 'C' % Clear All
set(handles.checkbox6,'Value',0)
set(handles.checkbox7,'Value',0) 
set(handles.checkbox8,'Value',0)
set(handles.checkbox9,'Value',0)
set(handles.checkbox10,'Value',0)
set(handles.checkbox11,'Value',0)
set(handles.pushbutton2,'String','Select All')
end 

function pushbutton3_Callback(hObject, eventdata, handles)
S=get(handles.pushbutton3,'String');
if S(1) == 'S' % Select All
set(handles.checkbox12,'Value',1)
set(handles.checkbox13,'Value',1)
set(handles.checkbox14,'Value',1)
set(handles.checkbox15,'Value',1)
set(handles.checkbox16,'Value',1)
set(handles.checkbox17,'Value',1)
set(handles.pushbutton3,'String','Clear All')
elseif S(1) == 'C' % Clear All
set(handles.checkbox12,'Value',0)
set(handles.checkbox13,'Value',0)
set(handles.checkbox14,'Value',0)
set(handles.checkbox15,'Value',0)
set(handles.checkbox16,'Value',0)
set(handles.checkbox17,'Value',0)
set(handles.pushbutton3,'String','Select All')
end

function pushbutton4_Callback(hObject, eventdata, handles)
if get(handles.radiobutton2,'Value') == 1
DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
set(handles.edit17,'String',DIRNAME)
end

% The main button that starts data acquisition
function pushbutton5_Callback(hObject, eventdata, handles)
% set(handles.pushbutton5,'String','For a new request reissue get_hycom')
% uiresume(handles.figure1)
%% Turn off ability to re-issue "Get Data"
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait ...');
pause(.1)

%% GET INPUT FROM GUI 
request=InputGet(hObject, eventdata, handles);

%save gui_hycom_request.mat request -MAT %-V6 %-APPEND
% Remember request for future sessions.
pname = strrep(mfilename('fullpath'),mfilename,'');
fname = [mfilename,'_request','.mat'];
save([pname,fname],'request','-mat')

%'gui_hycom_request.mat';
if exist([pname,fname],'file') 
    set (handles.pushbutton8,'Enable','On')
end

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
%assignin('base','request',request);

get_hycom(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25]);

function pushbutton6_Callback(hObject, eventdata, handles)
%web 'http://oceanmodeling.rsmas.miami.edu/hycom/' -browser
web 'http://hycom.coaps.fsu.edu/data/atlantic_info.html' -browser
function pushbutton7_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton9_Callback(hObject, eventdata, handles)
web 'http://hycom.coaps.fsu.edu/thredds/dodsC/atl_ops.info' -browser
function pushbutton10_Callback(hObject, eventdata, handles)
web 'http://www.nopp.org/' -browser

function request=InputGet(hObject, eventdata, handles)

DSI=LoadDSI(hObject, eventdata, handles);
R.Fields=DSI.Fields;
R.Fields(:,end+1)={'n'}; % add one more column to indicated checked fields
[N1,N2]=size(R.Fields);
% select only checked variables
for k=1:N1
CBNUM=num2str(DSI.Fields_CBNum{k});
    if eval(['get(handles.checkbox' CBNUM ',''Value'')']) == 1
    R.Fields{k,end}='y';    
    end
end

% get strings from GUI menu and convert them to numbers
yyyy=deblank(get(handles.edit1,'String'));
mm=deblank(get(handles.edit2,'String')); if length(mm) == 1 mm=['0' mm]; end
dd=deblank(get(handles.edit3,'String')); if length(dd) == 1 dd=['0' dd]; end
R.DATE1=[yyyy mm dd];

yyyy=deblank(get(handles.edit4,'String'));
mm=deblank(get(handles.edit5,'String')); if length(mm) == 1 mm=['0' mm]; end
dd=deblank(get(handles.edit6,'String')); if length(dd) == 1 dd=['0' dd]; end
R.DATE2=[yyyy mm dd];

R.LAT1=str2num(deblank(get(handles.edit7,'String')));
R.LAT2=str2num(deblank(get(handles.edit8,'String')));
R.LON1=str2num(deblank(get(handles.edit9,'String')));
R.LON2=str2num(deblank(get(handles.edit10,'String')));
R.DEPTH1=str2num(deblank(get(handles.edit11,'String')));
R.DEPTH2=str2num(deblank(get(handles.edit12,'String')));
R.DATEINCR=str2num(deblank(get(handles.edit13,'String')));
R.LATINCR=str2num(deblank(get(handles.edit14,'String')));
R.LONINCR=str2num(deblank(get(handles.edit15,'String')));
R.LEVELINCR=str2num(deblank(get(handles.edit16,'String')));
R.DIRNAME=deblank(get(handles.edit17,'String'));
R.FNPREFIX=deblank(get(handles.edit18,'String'));

R.SaveWorkspace='n';
if get(handles.radiobutton1,'Value') == 1
R.SaveWorkspace='y'; % save extracted data in workspace variables
end
R.SaveFiles='n';
if get(handles.radiobutton2,'Value') == 1
R.SaveFiles='y'; % save extracted data in disk files
end

S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');
R.SaveMode=deblank(S{j});

S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');
R.DataSetBranch=S{j};

% R.RequestDate=datestr(now,'yyyy-mm-dd HH:MM:SS');
request=R;
handles.request=request;

% Load Last request
function pushbutton8_Callback(hObject, eventdata, handles)
pname = strrep(mfilename('fullpath'),mfilename,'');
fname = [mfilename,'_request','.mat'];
if exist([pname,fname],'file')
load([pname,fname]);
else
msgbox(['File ',pname,fname,' .mat does not exist.']);
return
end

if ~exist('request','var')
    request = Request;
end

R=request;

load dsi_hycom.mat % List
j = STRMATCH(R.DataSetBranch,List.DataSetBranch);
set(handles.popupmenu2,'Value',j);
CheckRanges(hObject, eventdata, handles)

% select only checked variables
[L1,L2]=size(R.Fields);
for k=1:L1
CBNUM=num2str(R.Fields{k,L2-1});    
eval(['set(handles.checkbox' CBNUM ',''Value'',0)'])
    if R.Fields{k,end}=='y';
    eval(['set(handles.checkbox' CBNUM ',''Value'',1)']) 
    end
end

% get strings from GUI menu and convert them to numbers
set(handles.edit1,'String',R.DATE1(1:4));
set(handles.edit2,'String',R.DATE1(5:6)); 
set(handles.edit3,'String',R.DATE1(7:8)); 
set(handles.edit4,'String',R.DATE2(1:4));
set(handles.edit5,'String',R.DATE2(5:6)); 
set(handles.edit6,'String',R.DATE2(7:8)); 
set(handles.edit7,'String',num2str(R.LAT1));
set(handles.edit8,'String',num2str(R.LAT2));
set(handles.edit9,'String',num2str(R.LON1));
set(handles.edit10,'String',num2str(R.LON2));
set(handles.edit11,'String',num2str(R.DEPTH1));
set(handles.edit12,'String',num2str(R.DEPTH2));
set(handles.edit13,'String',num2str(R.DATEINCR));
set(handles.edit14,'String',num2str(R.LATINCR));
set(handles.edit15,'String',num2str(R.LONINCR));
set(handles.edit16,'String',num2str(R.LEVELINCR));
set(handles.edit17,'String',R.DIRNAME);
set(handles.edit18,'String',R.FNPREFIX);

LevelsOnOff(hObject, eventdata, handles)

set(handles.radiobutton1,'Value',0);
if R.SaveWorkspace=='y'
    set(handles.radiobutton1,'Value',1); 
end
set(handles.radiobutton2,'Value',0);
if R.SaveFiles=='y'
    set(handles.radiobutton2,'Value',1); 
end

S=get(handles.popupmenu1,'String');
j=find(strcmp(S,R.SaveMode));
if isempty(j) j=1; end
set(handles.popupmenu1,'Value',j);

SaveFilesOnOff(hObject, eventdata, handles)

function SaveFilesOnOff(hObject, eventdata, handles)   
if get(handles.radiobutton2,'Value') == 0
    set(handles.edit17,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit18,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton2,'Value') == 1
    set(handles.edit17,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit18,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

function LevelsOnOff(hObject, eventdata, handles)   
L4D=get(handles.checkbox1,'Value')|get(handles.checkbox2,'Value')|...
    get(handles.checkbox3,'Value')|get(handles.checkbox4,'Value')|...
    get(handles.checkbox5,'Value');   
if L4D==0
    set(handles.edit11,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit12,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit16,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif L4D==1
    set(handles.edit11,'BackgroundColor',[1.  1.  1. ],'Enable','On')
    set(handles.edit12,'BackgroundColor',[1.  1.  1. ],'Enable','On')
    set(handles.edit16,'BackgroundColor',[1.  1.  1. ],'Enable','On')
end  

% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
function popupmenu2_CreateFcn(hObject, eventdata, handles)
function CheckRanges(hObject, eventdata, handles)
% depending on the checked GUI buttons update appearence of GUI menu
load dsi_hycom.mat % List

set(handles.popupmenu2,'String',List.DataSetBranch(:,1)); % long name for menu

DSI=LoadDSI(hObject, eventdata, handles);

set(handles.text8,'String',...
['Available time range: [' datestr(DSI.Range.Time1,'yyyy-mm-dd') ' to ' datestr(DSI.Range.Time2,'yyyy-mm-dd') ']'])
set(handles.text16,'String',...
['Available latitude range: [' num2str(DSI.Range.Latitude1) ' to ' num2str(DSI.Range.Latitude2) ']'])
if ~strcmp(DSI.DataSetBranch,'HYCOM_Atlantic_Ocean_Prediction_System')
set(handles.text16,'String',...
['Available latitude range: [' num2str(DSI.Range.Latitude1) ' to ' num2str(DSI.Range.Latitude2) '] plus polar patch'])
end    
set(handles.text20,'String',...
['Available longitude range: [' num2str(DSI.Range.Longitude1) ' to ' num2str(DSI.Range.Longitude2) ']'])

%% make visible and active only checkboxes corresponding to existing variables
L=[1:1:17]; % all field checkboxes
for k=1:length(L)
CBNUM=num2str(L(k));
%eval(['set(handles.checkbox' CBNUM ',''Visible'',''off'',''Enable'',''off'')'])
eval(['set(handles.checkbox' CBNUM ',''Enable'',''off'')'])
end

for k=1:length(DSI.Fields(:,1))
    FIELDMENU=DSI.Fields_NameMenu{k};
    CBNUM=num2str(DSI.Fields_CBNum{k});
 %  eval(['set(handles.checkbox' CBNUM ',''Visible'',''on'',''Enable'',''on'',''String'',''' FIELDMENU ''')'])
    eval(['set(handles.checkbox' CBNUM ',''Enable'',''on'',''String'',''' FIELDMENU ''')'])

end
%
%S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');S=deblank(S{j});
%TXT=['Temporal resolution is ' S];
%set(handles.text39,'String',TXT,'ForegroundColor',[0 0 1])
%S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');S=deblank(S{j});
%TXT=['Spatial resolution is ' S];
%set(handles.text40,'String',TXT,'ForegroundColor',[0 0 1])

function DSI=LoadDSI(hObject, eventdata, handles)
S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');
R.DataSetBranch=S{j};

%example: load DSI_OceanColor_MODIS_4km_8day_hdf.mat
S=['load dsi_hycom.mat DSI_' R.DataSetBranch];
eval(['load dsi_hycom.mat DSI_' R.DataSetBranch])
eval(['DSI=DSI_' R.DataSetBranch ';'])
eval(['clear DSI_' R.DataSetBranch ';'])
