function varargout = gui_oceancolor(varargin)
% Boots-up OceanColor GUI, interacts with user via interface.
% gui_oceancolor M-file for gui_oceancolor.fig
%
% INPUT(S):
%
%   [none]
%
% OUTPUT(S):
%
%   h -- (optional) GUI handle
%
% OPeNDAP Science Team
% Copyright 2007, 2008
% $Version 2.0.0$

%==========================================================================
% Meri Sheremet
% November 2007
%
% REVISION HISTORY:
% 2007/11/20 created
% 2008/06/15 modified for compiled version, ceb
%==========================================================================

% Last Modified by GUIDE v2.5 21-Feb-2008 17:54:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_oceancolor_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_oceancolor_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui_oceancolor is made visible.
function gui_oceancolor_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui_oceancolor (see VARARGIN)

% Set interface name.
filename = 'get_oceancolor';
txt = ['NASA/REASoN Ocean Data Portal - '];
tmp1 = ['Ocean Color GUI'];
tmp2 = '';
txt = [txt,tmp1];
if (~isdeployed)
    tmp2 = strrep(op_version('mfile',filename),'Version ','');
    txt = [txt,' (Ver ',tmp2,')'];
end
set(hObject,'Name',txt);

% Place logos on the GUI with links
% determine screen resolution and size of character in pixels
Units0=get(0,'Units'); % save initial settings
set(0,'Units','characters');
SSC=get(0,'ScreenSize'); % screen size in characters
set(0,'Units','pixels');
SSP=get(0,'ScreenSize'); % screen size in pixels
set(0,'Units',Units0); % restore to original units
ppcx=SSP(3)/SSC(3); % pixels per character along x
ppcy=SSP(4)/SSC(4); % pixels per character along y

[img,MAP]=imread('logo_opendap.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton7,'CData',img)
pos = get(handles.pushbutton7,'position'); %units will be in characters
set(handles.pushbutton7,'position',[pos(1),pos(2),CX,CY]);  

[img,MAP]=imread('logo_nasa1.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton8,'CData',img)
pos = get(handles.pushbutton8,'position'); %units will be in characters
set(handles.pushbutton8,'position',[pos(1),pos(2),CX,CY]);  

[img,MAP]=imread('logo_nasa_gsfc.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton3,'CData',img)
pos = get(handles.pushbutton3,'position'); %units will be in characters
set(handles.pushbutton3,'position',[pos(1),pos(2),CX,CY]);  

[img,MAP]=imread('logo_csiro.jpg');
[NY,NX,N3]=size(img);
CX=(NX+8)/ppcx;         % button size in characters including 4 pixel grace margin
CY=(NY+12)/ppcy;
set(handles.pushbutton4,'CData',img)
pos = get(handles.pushbutton4,'position'); %units will be in characters
set(handles.pushbutton4,'position',[pos(1),pos(2),CX,CY]);  

set(handles.edit11,'String',num2str(1));
set(handles.edit12,'String',num2str(1));
set(handles.edit13,'String',num2str(1));

txt=['Help'];
op_tooltipwrap(handles.pushbutton9,txt,50);

[img,MAP]=imread('logo_questionmark.jpg');
% [NY,NX,N3]=size(img);
% CX=(NX+8)/ppcx;
% CY=(NY+12)/ppcy;
% set(handles.pushbutton9,'CData',img)
% pos = get(handles.pushbutton9,'position'); %units will be in characters
% set(handles.pushbutton9,'position',[pos(1),pos(2),CX,CY]);
[N1,N2,N3]=size(img);
set(handles.pushbutton9,'string','')
set(handles.pushbutton9,'CData',img)
set(handles.pushbutton9,'Units','pixels')
pos = get(handles.pushbutton9,'position');
set(handles.pushbutton9,'position',[pos(1) pos(2) N1 N2])

if get(handles.radiobutton1,'Value')==0 & get(handles.radiobutton2,'Value')==0 ...
 & get(handles.radiobutton3,'Value')==0 & get(handles.radiobutton4,'Value')==0 
    set(handles.radiobutton1,'Value',1)
end
    
if get(handles.radiobutton5,'Value')==0 & get(handles.radiobutton6,'Value')==0
set(handles.radiobutton5,'Value',1)
end

if get(handles.radiobutton6,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton6,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

% Make 'Load Last Request' button inactive when file gui_xxx_request.mat is
% absent.
if ~exist('gui_oceancolor_request.mat','file') 
    set(handles.pushbutton5,'Enable','Off')
end

set(handles.checkbox210,'Visible','off','Enable','off') % disable temporary
CheckRanges(hObject, eventdata, handles)
% Choose default command line output for gui_oceancolor
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui_oceancolor wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = gui_oceancolor_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function radiobutton1_Callback(hObject, eventdata, handles)
%CZCS
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '1']},{[S '2'];[S '3'];[S '4']})
set(handles.popupmenu1,'String',{'8day';'monthly';},'Value',1);
set(handles.popupmenu2,'String',{'9km';},'Value',1);
CheckRanges(hObject, eventdata, handles)

function radiobutton2_Callback(hObject, eventdata, handles)
% MODIS
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '2']},{[S '1'];[S '3'];[S '4']})
set(handles.popupmenu1,'String',{'3day';'8day';},'Value',1);
set(handles.popupmenu2,'String',{'4km';'9km';},'Value',1);
CheckRanges(hObject, eventdata, handles)

function radiobutton3_Callback(hObject, eventdata, handles)
% SeaWiFS
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '3']},{[S '1'];[S '2'];[S '4']})
set(handles.popupmenu1,'String',{'8day';},'Value',1);
set(handles.popupmenu2,'String',{'9km';},'Value',1);
CheckRanges(hObject, eventdata, handles)

function radiobutton4_Callback(hObject, eventdata, handles)
% Merged MODIS & SeaWiFS
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '4']},{[S '1'];[S '2'];[S '3']})
set(handles.popupmenu1,'String',{'1day';'8day';},'Value',1);
set(handles.popupmenu2,'String',{'9km';},'Value',1);
CheckRanges(hObject, eventdata, handles)

function radiobutton5_Callback(hObject, eventdata, handles)
function radiobutton6_Callback(hObject, eventdata, handles)
SaveFilesOnOff(hObject, eventdata, handles)

function checkbox101_Callback(hObject, eventdata, handles)
function checkbox102_Callback(hObject, eventdata, handles)
function checkbox201_Callback(hObject, eventdata, handles)
function checkbox202_Callback(hObject, eventdata, handles)
function checkbox203_Callback(hObject, eventdata, handles)
function checkbox204_Callback(hObject, eventdata, handles)
function checkbox205_Callback(hObject, eventdata, handles)
function checkbox206_Callback(hObject, eventdata, handles)
function checkbox207_Callback(hObject, eventdata, handles)
function checkbox208_Callback(hObject, eventdata, handles)
function checkbox209_Callback(hObject, eventdata, handles)
function checkbox210_Callback(hObject, eventdata, handles)
function checkbox301_Callback(hObject, eventdata, handles)
function checkbox302_Callback(hObject, eventdata, handles)
function checkbox303_Callback(hObject, eventdata, handles)
function checkbox304_Callback(hObject, eventdata, handles)
function checkbox305_Callback(hObject, eventdata, handles)
function checkbox306_Callback(hObject, eventdata, handles)
function checkbox307_Callback(hObject, eventdata, handles)
function checkbox401_Callback(hObject, eventdata, handles)

function popupmenu1_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');S=deblank(S{j});
TXT=['Temporal resolution is ' S];
set(handles.text39,'String',TXT,'ForegroundColor',[0 0 1])
function popupmenu1_CreateFcn(hObject, eventdata, handles)
function popupmenu2_Callback(hObject, eventdata, handles)
CheckRanges(hObject, eventdata, handles)
S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');S=deblank(S{j});
TXT=['Spatial resolution is ' S];
set(handles.text40,'String',TXT,'ForegroundColor',[0 0 1])
function popupmenu2_CreateFcn(hObject, eventdata, handles)
function popupmenu3_Callback(hObject, eventdata, handles)
function popupmenu3_CreateFcn(hObject, eventdata, handles)

function edit1_Callback(hObject, eventdata, handles)
function edit1_CreateFcn(hObject, eventdata, handles)
function edit2_Callback(hObject, eventdata, handles)
function edit2_CreateFcn(hObject, eventdata, handles)
function edit3_Callback(hObject, eventdata, handles)
function edit3_CreateFcn(hObject, eventdata, handles)
function edit4_Callback(hObject, eventdata, handles)
function edit4_CreateFcn(hObject, eventdata, handles)
function edit5_Callback(hObject, eventdata, handles)
function edit5_CreateFcn(hObject, eventdata, handles)
function edit6_Callback(hObject, eventdata, handles)
function edit6_CreateFcn(hObject, eventdata, handles)
function edit7_Callback(hObject, eventdata, handles)
function edit7_CreateFcn(hObject, eventdata, handles)
function edit8_Callback(hObject, eventdata, handles)
function edit8_CreateFcn(hObject, eventdata, handles)
function edit9_Callback(hObject, eventdata, handles)
function edit9_CreateFcn(hObject, eventdata, handles)
function edit10_Callback(hObject, eventdata, handles)
function edit10_CreateFcn(hObject, eventdata, handles)

function edit11_Callback(hObject, eventdata, handles)
function edit11_CreateFcn(hObject, eventdata, handles)
function edit12_Callback(hObject, eventdata, handles)
function edit12_CreateFcn(hObject, eventdata, handles)
function edit13_Callback(hObject, eventdata, handles)
function edit13_CreateFcn(hObject, eventdata, handles)

function edit14_Callback(hObject, eventdata, handles)
function edit14_CreateFcn(hObject, eventdata, handles)
function edit15_Callback(hObject, eventdata, handles)
function edit15_CreateFcn(hObject, eventdata, handles)

function pushbutton1_Callback(hObject, eventdata, handles)
% Main button that starts data acquisition.

% Turn off ability to re-issue "Get Data."
set(hObject,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off','String','Please wait...');
pause(.1)

% Get input from user.
request=InputGet(hObject, eventdata, handles);

% Save request to .mat file.
filename = 'gui_oceancolor_request.mat';
if (~isdeployed)
    pname = mfilename('fullpath');
    pname = pname(1:length(pname)-length(mfilename)); %mfilename does not have .m in it
    filename = [pname,filename];
end
save(filename,'request','-mat')
set(handles.pushbutton5,'Enable','On')

R=request;

%    if isempty(R.LAT1) 
%        set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25])
%        return; 
%    end

% If it passes inspection, send down to user's workspace
% as variable "request". Then the user can get the data
%assignin('base','request',request);

get_oceancolor(request);

set(hObject,'Enable','On','String','Get Data','BackgroundColor',[0 1. 0.25])

function pushbutton2_Callback(hObject, eventdata, handles)
if get(handles.radiobutton6,'Value') == 1
DIRNAME=uigetdir(pwd,'Select a Directory for Downloading Files');
set(handles.edit14,'String',DIRNAME)
end
function pushbutton3_Callback(hObject, eventdata, handles)
web 'http://oceancolor.gsfc.nasa.gov/' -browser
function pushbutton5_Callback(hObject, eventdata, handles)
LoadLastRequest(hObject, eventdata, handles)
function pushbutton7_Callback(hObject, eventdata, handles)
web 'http://www.opendap.org/' -browser
function pushbutton6_Callback(hObject, eventdata, handles)
dsi_oceancolor
function pushbutton4_Callback(hObject, eventdata, handles)
web 'http://www.marine.csiro.au/remotesensing/restricted/un001.html' -browser 
function pushbutton8_Callback(hObject, eventdata, handles)
%web 'http://www.nasa.gov/topics/earth/index.html' -browser
web 'http://www.nasa.gov' -browser

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Get Input from GUI menu
function request=InputGet(hObject, eventdata, handles)

S1=deblank(get(handles.edit1,'String'));
S2=deblank(get(handles.edit2,'String'));
S3=deblank(get(handles.edit3,'String'));
S4=deblank(get(handles.edit4,'String'));
S5=deblank(get(handles.edit5,'String'));
S6=deblank(get(handles.edit6,'String'));

R.DATE1='00000000';
R.DATE1(4-length(S1)+1:4)=S1;
R.DATE1(6-length(S2)+1:6)=S2;
R.DATE1(8-length(S3)+1:8)=S3;
R.DATE2='00000000';
R.DATE2(4-length(S4)+1:4)=S4;
R.DATE2(6-length(S5)+1:6)=S5;
R.DATE2(8-length(S6)+1:8)=S6;

R.LAT1=str2num(deblank(get(handles.edit7,'String')));
R.LAT2=str2num(deblank(get(handles.edit8,'String')));
R.LON1=str2num(deblank(get(handles.edit9,'String')));
R.LON2=str2num(deblank(get(handles.edit10,'String')));

R.DATEINCR=str2num(deblank(get(handles.edit11,'String')));
R.LATINCR=str2num(deblank(get(handles.edit12,'String')));
R.LONINCR=str2num(deblank(get(handles.edit13,'String')));

if get(handles.radiobutton1,'Value') == 1 DSN='OceanColor_CZCS';               DSNum=1; end
if get(handles.radiobutton2,'Value') == 1 DSN='OceanColor_MODIS';              DSNum=2; end
if get(handles.radiobutton3,'Value') == 1 DSN='OceanColor_SeaWiFS';            DSNum=3; end
if get(handles.radiobutton4,'Value') == 1 DSN='OceanColor_MergedMODISSeaWiFS'; DSNum=4; end

S=get(handles.popupmenu1,'String');
j=get(handles.popupmenu1,'Value');
R.TAvg=deblank(S{j}); % only one value
S=get(handles.popupmenu2,'String');
j=get(handles.popupmenu2,'Value');
R.HRes=deblank(S{j}); % only one value

R.DataSetBranch=[DSN '_' R.HRes '_' R.TAvg '_' 'hdf'];
%example: load DSI_OceanColor_MODIS_4km_8day_hdf.mat
eval(['load dsi_oceancolor.mat DSI_' R.DataSetBranch])
eval(['DSI=DSI_' R.DataSetBranch ';'])
eval(['clear DSI_' R.DataSetBranch ';'])

R.Fields=DSI.Fields;
R.Fields(:,end+1)={'n'}; % add one more column to indicated checked fields
for k=1:length(R.Fields(:,end))
    CBNUM=num2str(100*DSNum+k);
    if eval(['get(handles.checkbox' CBNUM ',''Value'')==1']) R.Fields{k,end}='y'; end
end

SaveModeL={'opendap';'native'};
j=get(handles.popupmenu3,'Value');
R.SaveMode=SaveModeL{j};

R.SaveWorkspace='n'; 
if get(handles.radiobutton5,'Value') == 1 R.SaveWorkspace='y'; end
R.SaveFiles='n'; 
if get(handles.radiobutton6,'Value') == 1 R.SaveFiles='y'; end
R.DIRNAME =deblank(get(handles.edit14,'String'));
if isempty(R.DIRNAME) R.DIRNAME=''; end
R.FNPREFIX=deblank(get(handles.edit15,'String'));

%% Get default command line output from handles structure.   
%R.RequestDate=datestr(now,'yyyy-mm-dd HH:MM:SS');
request=R;

%handles.output = hObject;
%guidata(hObject, handles);

% Load Last request
function LoadLastRequest(hObject, eventdata, handles)
filename = 'gui_oceancolor_request.mat';
if exist(filename,'file')
    load(filename)
else
    msgbox(['File ',filename,' does not exist.']);
    return
end

R=request;

set(handles.edit1,'String',R.DATE1(1:4));
set(handles.edit2,'String',R.DATE1(5:6)); 
set(handles.edit3,'String',R.DATE1(7:8)); 
set(handles.edit4,'String',R.DATE2(1:4));
set(handles.edit5,'String',R.DATE2(5:6)); 
set(handles.edit6,'String',R.DATE2(7:8)); 
set(handles.edit7,'String',num2str(R.LAT1));
set(handles.edit8,'String',num2str(R.LAT2));
set(handles.edit9,'String',num2str(R.LON1));
set(handles.edit10,'String',num2str(R.LON2));
set(handles.edit11,'String',num2str(R.DATEINCR));
set(handles.edit12,'String',num2str(R.LATINCR));
set(handles.edit13,'String',num2str(R.LONINCR));

if strcmp(R.DataSetBranch(12:15),'CZCS')
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '1']},{[S '2'];[S '3'];[S '4']})
DSNum=1; TAvgL={'8day';'monthly';};HResL={'9km';}; 
end 
if strcmp(R.DataSetBranch(12:16),'MODIS')    
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '2']},{[S '1'];[S '3'];[S '4']})
DSNum=2; TAvgL={'3day';'8day';};   HResL={'4km';'9km';}; 
end 
if strcmp(R.DataSetBranch(12:18),'SeaWiFS')  
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '3']},{[S '1'];[S '2'];[S '4']})
DSNum=3; TAvgL={'8day';};          HResL={'9km';}; 
end 
if strcmp(R.DataSetBranch(12:17),'Merged')   
S='radiobutton';
CheckExclusive(hObject, eventdata, handles,{[S '4']},{[S '1'];[S '2'];[S '3']})
DSNum=4; TAvgL={'1day';'8day';};   HResL={'9km';}; 
end 

for k=1:length(R.Fields(:,end))
    CBNUM=num2str(100*DSNum+k);
    eval(['set(handles.checkbox' CBNUM ',''Value'',0)'])
    if R.Fields{k,end}=='y' eval(['set(handles.checkbox' CBNUM ',''Value'',1)']) ; end
end

set(handles.popupmenu1,'String',TAvgL);
j=find(strcmp(TAvgL,R.TAvg));
if isempty(j) j=1; end
set(handles.popupmenu1,'Value',j);
set(handles.popupmenu2,'String',HResL);
j=find(strcmp(HResL,R.HRes));
if isempty(j) j=1; end
set(handles.popupmenu2,'Value',j);

%example: load DSI_OceanColor_MODIS_4km_8day_hdf.mat
S=['load dsi_oceancolor.mat DSI_' R.DataSetBranch];
eval(['load dsi_oceancolor.mat DSI_' R.DataSetBranch])
eval(['DSI=DSI_' R.DataSetBranch ';'])
eval(['clear DSI_' R.DataSetBranch ';'])
set(handles.text6,'String',...
['Available time range: [' datestr(DSI.Range.Time1,'yyyy-mm-dd') ' to ' datestr(DSI.Range.Time2,'yyyy-mm-dd') ']'])
set(handles.text15,'String',...
['Available latitude range: [' num2str(DSI.Range.Latitude1) ' to ' num2str(DSI.Range.Latitude2) ']'])
set(handles.text19,'String',...
['Available longitude range: [' num2str(DSI.Range.Longitude1) ' to ' num2str(DSI.Range.Longitude2) ']'])

CheckRanges(hObject, eventdata, handles)

SaveModeL={'opendap';'native'};
set(handles.popupmenu3,'String',SaveModeL);
j=find(strcmp(SaveModeL,R.SaveMode));
if isempty(j) j=1; end
set(handles.popupmenu3,'Value',j);

if R.SaveWorkspace=='y' set(handles.radiobutton5,'Value',1); end
if R.SaveFiles=='y' set(handles.radiobutton6,'Value',1); end
set(handles.edit14,'String',R.DIRNAME);
set(handles.edit15,'String',R.FNPREFIX);
SaveFilesOnOff(hObject, eventdata, handles)

function CheckExclusive(hObject, eventdata, handles, Us, Them)
% sets value of Us to 1 and Them to 0
% example: Us={'radiobutton1'}; Them={'radiobutton2';'radiobutton3'}
eval(['set(handles.' Us{1} ',''Value'',1)'])
for k=1:length(Them)
eval(['set(handles.' Them{k} ',''Value'',0)'])
end

function SaveFilesOnOff(hObject, eventdata, handles)   
if get(handles.radiobutton6,'Value') == 0
    set(handles.edit14,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
    set(handles.edit15,'BackgroundColor',[0.8 0.8 0.8],'Enable','Off')
elseif get(handles.radiobutton6,'Value') == 1
    set(handles.edit14,'BackgroundColor',[1. 1. 1.],'Enable','On')
    set(handles.edit15,'BackgroundColor',[1. 1. 1.],'Enable','On')
end

function CheckRanges(hObject, eventdata, handles)

DSNum=0;
if get(handles.radiobutton1,'Value') == 1 
    DSN='OceanColor_CZCS';
    DSNum=1; TAvgL={'8day';'monthly';};HResL={'9km';};  
end
if get(handles.radiobutton2,'Value') == 1 
    DSN='OceanColor_MODIS';
    DSNum=2; TAvgL={'3day';'8day';};   HResL={'4km';'9km';};                
end
if get(handles.radiobutton3,'Value') == 1 
    DSN='OceanColor_SeaWiFS';
    DSNum=3; TAvgL={'8day';};          HResL={'9km';};  
end
if get(handles.radiobutton4,'Value') == 1 
    DSN='OceanColor_MergedMODISSeaWiFS'; 
    DSNum=4; TAvgL={'1day';'8day';};   HResL={'9km';};  
end
if DSNum==0 return; end

set(handles.popupmenu1,'String',TAvgL);
set(handles.popupmenu2,'String',HResL);
   
S=get(handles.popupmenu1,'String');
j=get(handles.popupmenu1,'Value');
if isempty(j) return; end
R.TAvg=deblank(S{j}); % only one value
S=get(handles.popupmenu2,'String');
j=get(handles.popupmenu2,'Value');
if isempty(j) return; end
R.HRes=deblank(S{j}); % only one value

R.DataSetBranch=[DSN '_' R.HRes '_' R.TAvg '_' 'hdf'];
%CheckTLLRanges(hObject, eventdata, handles,R.DataSetBranch)
%example: load DSI_OceanColor_MODIS_4km_8day_hdf.mat
S=['load dsi_oceancolor.mat DSI_' R.DataSetBranch];
eval(['load dsi_oceancolor.mat DSI_' R.DataSetBranch])
eval(['DSI=DSI_' R.DataSetBranch ';'])
eval(['clear DSI_' R.DataSetBranch ';'])
set(handles.text6,'String',...
['Available time range: [' datestr(DSI.Range.Time1,'yyyy-mm-dd') ' to ' datestr(DSI.Range.Time2,'yyyy-mm-dd') ']'])
set(handles.text15,'String',...
['Available latitude range: [' num2str(DSI.Range.Latitude1) ' to ' num2str(DSI.Range.Latitude2) ']'])
set(handles.text19,'String',...
['Available longitude range: [' num2str(DSI.Range.Longitude1) ' to ' num2str(DSI.Range.Longitude2) ']'])

% make visible and active only checkboxes corresponding to existing
% variables
L=[(101:102) (201:210) (301:307) (401)]; % all field checkboxes
for k=1:length(L)
CBNUM=num2str(L(k));
%eval(['set(handles.checkbox' CBNUM ',''Visible'',''off'',''Enable'',''off'')'])
eval(['set(handles.checkbox' CBNUM ',''Enable'',''off'')'])
end
for k=1:length(DSI.Fields(:,1))
    FIELD=DSI.Fields{k,1};
    CBNUM=num2str(100*DSNum+k);
%    eval(['set(handles.checkbox' CBNUM ',''Visible'',''on'',''Enable'',''on'',''String'',''' FIELD ''')'])
    eval(['set(handles.checkbox' CBNUM ',''Enable'',''on'',''String'',''' FIELD ''')'])
%    if R.Fields{k,end}=='y' eval(['set(handles.checkbox' CBNUM ',''Value'',1)']) ; end
end

S=get(handles.popupmenu1,'String');j=get(handles.popupmenu1,'Value');S=deblank(S{j});
TXT=['Temporal resolution is ' S];
set(handles.text39,'String',TXT,'ForegroundColor',[0 0 1])
S=get(handles.popupmenu2,'String');j=get(handles.popupmenu2,'Value');S=deblank(S{j});
TXT=['Spatial resolution is ' S];
set(handles.text40,'String',TXT,'ForegroundColor',[0 0 1])

function pushbutton9_Callback(hObject, eventdata, handles)
h = op_timemessage('polar',0);